Onyx's blog

By Onyx, history, 21 month(s) ago, In English

Any optimize idea/hint about this problem?? initially have a idea about calculating trailing 0..... https://open.kattis.com/problems/inversefactorial

  • Vote: I like it
  • +19
  • Vote: I do not like it

| Write comment?
»
21 month(s) ago, # |
  Vote: I like it +5 Vote: I do not like it

There is an editorial on DMOJ: https://dmoj.ca/problem/naq16g.

»
21 month(s) ago, # |
  Vote: I like it +14 Vote: I do not like it

The title actually got me thinking of this unrelated task. Is it possible?

Can you find the value of $$$n < 10^9$$$, given n! mod (10^9 + 7) as the input? In case of multiple solutions, print any.

  • »
    »
    21 month(s) ago, # ^ |
      Vote: I like it +1 Vote: I do not like it
    • »
      »
      »
      21 month(s) ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Nice idea! Unfortunately, it is not fully correct as-is. The smallest failing test case is 21008! which happens to coincide with 11448! mod 10^9+7. I expect that doing this with two or three primes of that size simultaneously would be enough to fully solve the problem.

      But the problem-setters probably didn't anticipate this approach and prepare counter-tests for popular primes like 10^9+7 or 7*17*2^23+1.

  • »
    »
    21 month(s) ago, # ^ |
      Vote: I like it +6 Vote: I do not like it

    The comment actually got me thinking of this unrelated task. Is it possible?

    Can you find the value of $$$n<10^9$$$, given (b, b^n mod (10^9 + 7)) as the input? In case of multiple solutions, print any.

    • »
      »
      »
      21 month(s) ago, # ^ |
        Vote: I like it +13 Vote: I do not like it

      Is this simply BSGS Algorithm? ​It can be solved in $$$\sqrt{mod}$$$ time.

»
21 month(s) ago, # |
  Vote: I like it 0 Vote: I do not like it

An easy way is the following: find the number of trailing zeros to find the maximum power of 5 that divides this number. Using binary search, you can find the range of 5 integers $$$5n + \varepsilon$$$ with $$$0 \le \varepsilon < 5$$$ which are candidates for the inverse factorial of this number. Using divide and conquer and FFT, you can find the factorial of $$$(5n)!$$$ in $$$O(n \log^2 n)$$$ with a not-so-bad constant factor (since you can work in base $$$10^9$$$). Then count the number of digits in it. For every $$$n > 1$$$, these five numbers have a different number of digits, and the difference between the number of digits can be estimated easily. For $$$n = 1$$$ you can run a brute force.

»
21 month(s) ago, # |
  Vote: I like it +15 Vote: I do not like it

$$$\ln x!=x\ln x-x+\frac12\ln\sqrt{2\pi}+\frac12\ln x+o(1)$$$ (the o(1) term is between 0 and 0.1 for all $$$x>1$$$) so it might be possible to binary search for the value of $$$x$$$.

»
21 month(s) ago, # |
  Vote: I like it 0 Vote: I do not like it
#include <bits/stdc++.h>
using namespace std;

const int mod = 1e9 + 7;
int main(){
	ios::sync_with_stdio(false);cin.tie(0);
	
	string s;
	cin >> s;
	
	long long int yet = 0;
	
	for(char c : s){
		yet *= 10;
		yet += c-'0';
		yet %= mod;
	}
	
	long long int here = 1;
	for(int i = 1; ; i++){
		(here *= i) %= mod;
		
		if(here == yet){
			cout << i << '\n';
			return 0;
		}
	}
	
	return 0;
}